#ifndef RAINBOW_LINEAR_H
#define RAINBOW_LINEAR_H

#include "QColorMapAction.h"

class Rainbow_linear : public QColorMapAction
{
public:
    Rainbow_linear(QObject *parent) : QColorMapAction(tr("Linear Rainbow"),parent) {}

    void apply(vector<QRgb> &colormap)
    {
        int N=colormap.size();
        int N2=N>>1;
        double step=256.0/N2;
        double greenv=0.0;
        for(int i=0;i<N;i++)
        {
           int green=int(greenv);
           int red = ((i < N2) ? 255-green : 0);
           int blue = ((i >= N2) ? 255-green : 0);
           greenv+=step;
           colormap[i]=qRgb(red,green,blue);
        }
    }
};

#endif // RAINBOW_SOFT_H
